/*  $Id: event_trigger_win32.cpp,v 1.9 2003/07/20 22:30:53 grumbel Exp $
**
**  ClanLib Game SDK
**  Copyright (C) 2003  The ClanLib Team
**  For a total list of contributers see the file CREDITS.
**
**  This library is free software; you can redistribute it and/or
**  modify it under the terms of the GNU Lesser General Public
**  License as published by the Free Software Foundation; either
**  version 2.1 of the License, or (at your option) any later version.
**
**  This library is distributed in the hope that it will be useful,
**  but WITHOUT ANY WARRANTY; without even the implied warranty of
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
**  Lesser General Public License for more details.
**
**  You should have received a copy of the GNU Lesser General Public
**  License along with this library; if not, write to the Free Software
**  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
**
*/

#include "Core/precomp.h"
#include "event_trigger_win32.h"

/////////////////////////////////////////////////////////////////////////////
// CL_EventTrigger_Win32 construction:

CL_EventTrigger_Win32::CL_EventTrigger_Win32()
:
	wait_handle(NULL)
{
	wait_handle = CreateEvent(NULL, TRUE, FALSE, NULL);
}

CL_EventTrigger_Win32::~CL_EventTrigger_Win32()
{
	CloseHandle(wait_handle);
}

/////////////////////////////////////////////////////////////////////////////
// CL_EventTrigger_Win32 attributes:

bool CL_EventTrigger_Win32::get_flag() const
{
	return WaitForSingleObject(wait_handle, 0) != WAIT_TIMEOUT;
}

/////////////////////////////////////////////////////////////////////////////
// CL_EventTrigger_Win32 operations:

void CL_EventTrigger_Win32::reset() const
{
	ResetEvent(wait_handle);
}

void CL_EventTrigger_Win32::set_flag()
{
	SetEvent(wait_handle);
}

bool CL_EventTrigger_Win32::wait(int timeout) const
{
	DWORD result = WaitForSingleObject(
		wait_handle,
		(timeout == -1) ? INFINITE : timeout);

	return (result != WAIT_TIMEOUT);
}

/////////////////////////////////////////////////////////////////////////////
// CL_EventTrigger_Win32 implementation:
